<template>
  <div>
    <div class="flex flex-row-reverse my-4">
      <Button size="small" type="primary" @click="handleAdd()">add</Button>
    </div>
    <div class="flex flex-col">
      <div class="-my-2 overflow-x-auto sm:-mx-6 lg:-mx-8">
        <div class="py-2 align-middle inline-block min-w-full sm:px-6 lg:px-8">
          <div
            class="shadow overflow-hidden border-b border-gray-200 sm:rounded-lg"
          >
            <table class="min-w-full divide-y divide-gray-200">
              <thead class="bg-gray-50">
                <tr>
                  <th
                    scope="col"
                    class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                  >
                    Name
                  </th>
                  <th
                    scope="col"
                    class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                  >
                    Adress
                  </th>
                  <th
                    scope="col"
                    class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                  >
                    Status
                  </th>
                  <th
                    scope="col"
                    class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                  >
                    Phone
                  </th>
                  <th scope="col" class="relative px-6 py-3">
                    <span class="sr-only">Edit</span>
                  </th>
                </tr>
              </thead>
              <tbody class="bg-white divide-y divide-gray-200">
                <template v-for="user in users.data">
                  <tr :key="`userData${user.id}`">
                    <td class="px-6 py-4 whitespace-nowrap">
                      <div class="flex items-center">
                        <div class="flex-shrink-0 h-10 w-10">
                          <img
                            class="h-10 w-10 rounded-full"
                            src="~/assets/img/ava.png"
                            alt=""
                          />
                        </div>
                        <div class="ml-4">
                          <div class="text-sm font-medium text-gray-900">
                            {{ user.fullName }}
                          </div>
                          <div class="text-sm text-gray-500">
                            {{ user.email }}
                          </div>
                        </div>
                      </div>
                    </td>
                    <td class="px-6 py-4 whitespace-nowrap">
                      <div class="text-sm text-gray-900">
                        {{ user.address }}
                      </div>
                    </td>
                    <td class="px-6 py-4 whitespace-nowrap">
                      <span
                        class="px-2 inline-flex text-xs leading-5 font-semibold rounded-full bg-green-100 text-green-800"
                      >
                        Active
                      </span>
                    </td>
                    <td
                      class="px-6 py-4 whitespace-nowrap text-sm text-gray-500"
                    >
                      {{ user.phone }}
                    </td>
                    <td
                      class="px-6 py-4 whitespace-nowrap text-right text-sm font-medium"
                    >
                      <Button
                        type="text"
                        size="small"
                        @click="handleEdit(user.id)"
                        >Edit</Button
                      >
                      <Button
                        type="text danger"
                        size="small"
                        @click="handleDelete(user.id)"
                        >Delete</Button
                      >
                    </td>
                  </tr>
                </template>

                <!-- More rows... -->
              </tbody>
            </table>
          </div>
        </div>
      </div>
    </div>

    <Dialog title="Shipping address" :visible.sync="dialogFormVisible">
      <Form :model="form" :label-position="'right'" label-width="150px">
        <FormItem label="Email">
          <Input v-model="form.email" autocomplete="off"></Input>
        </FormItem>
        <FormItem label="Full Name">
          <Input v-model="form.fullName" autocomplete="off"></Input>
        </FormItem>
        <FormItem label="Password">
          <Input
            v-model="form.password"
            type="password"
            autocomplete="off"
          ></Input>
        </FormItem>
        <FormItem label="Address">
          <Input v-model="form.address" autocomplete="off"></Input>
        </FormItem>
        <FormItem label="Phone">
          <Input v-model="form.phone" autocomplete="off"></Input>
        </FormItem>
      </Form>
      <span slot="footer" class="dialog-footer">
        <Button @click="dialogFormVisible = false">Cancel</Button>
        <Button type="primary" @click="handleSave">Confirm</Button>
      </span>
    </Dialog>
  </div>
</template>
<script lang="ts">
import {
  Dialog,
  Form,
  Input,
  Button,
  FormItem,
  Dropdown,
  DropdownMenu,
  DropdownItem,
} from 'element-ui'
import { Vue, Component, Watch } from 'vue-property-decorator'
import { Action, Getter } from 'vuex-class'
import { UserDto } from '~/dto/user.dto'
import {
  ADD_USER_REQUEST,
  DELETE_USER_REQUEST,
  UPDATE_USER_REQUEST,
  USERS_REQUEST,
} from '~/store/users/usersTypes'
import {
  USER_DETAIL_CLEAR,
  USER_DETAIL_REQUEST,
} from '~/store/userDetail/userDetailTypes'

@Component({
  components: {
    Dialog,
    Form,
    FormItem,
    Input,
    Button,
    Dropdown,
    DropdownMenu,
    DropdownItem,
  },
})
export default class Login extends Vue {
  public dialogFormVisible: boolean = false
  public form: UserDto = new UserDto()

  @Action(USERS_REQUEST) userRequest: any
  @Action(USER_DETAIL_REQUEST) userDetailRequest: any
  @Action(USER_DETAIL_CLEAR) userDetailClear: any
  @Action(ADD_USER_REQUEST) addUserRequest: any
  @Action(DELETE_USER_REQUEST) deleteUserRequest: any
  @Action(UPDATE_USER_REQUEST) updateUserRequest: any

  @Getter('users') users: any
  @Getter('userDetail') userDetail: any

  @Watch('userDetail.data')
  onUserDatailSuccess() {
    this.form.id = this.userDetail.data.id
    this.form.email = this.userDetail.data.email
    this.form.fullName = this.userDetail.data.fullName
    this.form.phone = this.userDetail.data.phone
    this.form.address = this.userDetail.data.address
  }

  @Watch('userDetail.isError')
  onUserDetailIsError() {
    if (this.userDetail.isError) {
      setTimeout(() => {
        this.handleErrorNotif(this.userDetail.isError.message)
      }, 500)

      this.handleAuth(this.userDetail.isError.message)
    }
  }

  @Watch('users.isError')
  onUsersIsError() {
    if (this.users.isError) {
      setTimeout(() => {
        this.handleErrorNotif(this.users.isError.message)
      }, 500)
      this.handleAuth(this.users.isError.message)
    }
  }

  mounted() {
    this.userRequest()
  }

  handleDelete(id: number) {
    this.deleteUserRequest(id)
  }

  async handleEdit(id: number) {
    this.dialogFormVisible = true
    await this.userDetailRequest(id)
  }

  handleAdd() {
    this.dialogFormVisible = true
  }

  async handleSave() {
    if (this.form.id) {
      await this.updateUserRequest(this.form)
    } else {
      await this.addUserRequest(this.form)
    }
    await this.userDetailClear(new UserDto())
    this.dialogFormVisible = false
  }

  handleErrorNotif(message: any) {
    this.$notify.error({
      title: 'Error',
      message,
    })
  }

  handleAuth(message: string) {
    if (
      message === 'Request failed with status code 404' ||
      message === 'Request failed with status code 401'
    ) {
      this.$router.push('login')
    }
  }
}
</script>
<style>
.el-dropdown {
  vertical-align: top;
}
.el-dropdown + .el-dropdown {
  margin-left: 15px;
}
.el-icon-arrow-down {
  font-size: 12px;
}
</style>
